config/routes.rb
QuestionBank::Application.routes.draw do
  resources :user_groups

  resources :question_groups

  resources :tags

  resources :attempts

  resources :questions

  get '/questions/quiz/new' => 'questions#prepare_quiz', :as => 'prepare_quiz'
  post '/questions/quiz/new'=> 'questions#generate_quiz', :as => 'generate_quiz'
  match '/questions/quiz/tag/:tag/num/:number_of_questions/show' => 'questions#show_quiz', :as => 'show_quiz'

  get '/downloads/new' => 'downloads#new', :as => 'new_download'
  post '/downloads' => 'downloads#create', :as => 'create_download'

  get '/uploads/new' => 'uploads#new', :as => 'new_upload'
  post '/uploads' => 'uploads#create', :as => 'create_upload'
  get '/uploads/attribute/new' => 'uploads#new_attribute', :as => 'new_attribute'
  post '/uploads/attribute/new' => 'uploads#create_attribute', :as => 'create_attribute'

  post '/api/event/new' => 'api#new_event'
  
  root :to => "home#index"
  resources :users, :only => [:index, :show, :edit, :update ]
  match '/auth/:provider/callback' => 'sessions#create'
  match '/signin' => 'sessions#new', :as => :signin
  match '/signout' => 'sessions#destroy', :as => :signout
  match '/auth/failure' => 'sessions#failure'
end

app/models/user_group.rb
class UserGroup < ActiveRecord::Base
  has_and_belongs_to_many :users
  has_many :attempts, :through => :users
  after_save :save_roles

  def owner_user_ids
    if @owner_user_ids
      @owner_user_ids
    else
      users = User.by_role(:owner, self).map(&:id) 
    end
  end

  def owners
    users = User.by_role(:owner, self)
  end

  def viewers
    users = User.by_role(:viewer, self)
  end

  def owner_user_ids=(user_ids)
    @owner_user_ids = user_ids
  end


  def viewer_user_ids
    if @viewer_user_ids
      @viewer_user_ids
    else
      users = User.by_role(:viewer, self).map(&:id) 
    end
  end

  def viewer_user_ids=(user_ids)
    @viewer_user_ids = user_ids
  end

  resourcify

private
  # https://github.com/EppO/rolify/issues/63
  def save_roles
    # Save owners
    @owner_user_ids = @owner_user_ids.reject(&:empty?) if !@owner_user_ids.nil?
    users = User.by_role(:owner, self).where("users.id not IN (?)", @owner_user_ids)
    users.each do |user|
      user.remove_role :owner, self
    end
    users = User.where("users.id IN (?)", @owner_user_ids)
    users.each do |user|
      user.add_role :owner, self
    end


    # Save viewers
    @viewer_user_ids = @viewer_user_ids.reject(&:empty?) if !@viewer_user_ids.nil?
    users = User.by_role(:viewer, self).where("users.id not IN (?)", @viewer_user_ids)
    users.each do |user|
      user.remove_role :viewer, self
    end
    users = User.where("users.id IN (?)", @viewer_user_ids)
    users.each do |user|
      user.add_role :viewer, self
    end

end
end

app/controllers/user_groups_controller.rb
class UserGroupsController < ApplicationController
  load_and_authorize_resource
  # GET /user_groups
  # GET /user_groups.json
  def index
    @user_groups = UserGroup.accessible_by(current_ability)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @user_groups }
    end
  end

  # GET /user_groups/1
  # GET /user_groups/1.json
  def show
    @user_group = UserGroup.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @user_group }
    end
  end

  # GET /user_groups/new
  # GET /user_groups/new.json
  def new
    @user_group = UserGroup.new
    @users = User.all

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @user_group }
    end
  end

  # GET /user_groups/1/edit
  def edit
    @user_group = UserGroup.find(params[:id])
    @users = User.all
  end

  # POST /user_groups
  # POST /user_groups.json
  def create
    @user_group = UserGroup.new(params[:user_group])

    respond_to do |format|
      if @user_group.save
        format.html { redirect_to @user_group, notice: 'User group was successfully created.' }
        format.json { render json: @user_group, status: :created, location: @user_group }
      else
        format.html { render action: "new" }
        format.json { render json: @user_group.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /user_groups/1
  # PUT /user_groups/1.json
  def update
    @user_group = UserGroup.find(params[:id])

    respond_to do |format|
      if @user_group.update_attributes(params[:user_group])
        format.html { redirect_to @user_group, notice: 'User group was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @user_group.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /user_groups/1
  # DELETE /user_groups/1.json
  def destroy
    @user_group = UserGroup.find(params[:id])
    @user_group.destroy

    respond_to do |format|
      format.html { redirect_to user_groups_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/user_groups_helper.rb
module UserGroupsHelper
end

app/views/user_groups/_form.html.haml
= simple_form_for(@user_group) do |f|
  = f.error_notification

  .form-inputs
    = f.input :name
    = f.association :users, label: "Members", :collection => @users, :input_html => { :multiple => true }, :blank => false
    %h5 User With Privileges
    = f.input :owner_user_ids, label: "Owners", :collection => @users, :input_html => { :multiple => true }, :blank => false
    = f.input :viewer_user_ids, label: "Viewers", :collection => @users, :input_html => { :multiple => true }, :blank => false
    = f.submit 'Save', :class => 'btn btn-primary'

app/views/user_groups/edit.html.haml
%h3 Edit User Group

= render 'form'

app/views/user_groups/index.html.haml
%h3 User Groups

= link_to 'Create User Group', new_user_group_path, :class => 'btn btn-primary'

%br
%br

%table.table.table-striped
  %tr
    %th Name
    %th

  - @user_groups.each do |user_group|
    %tr
      %td= link_to user_group.name, user_group
      %td
        = link_to 'Destroy', user_group, method: :delete, data: { confirm: 'Are you sure?' }, :class => 'btn btn-danger index-action pull-right'
        = link_to 'Edit', edit_user_group_path(user_group), :class => 'btn btn-primary index-action pull-right'
%br

app/views/user_groups/new.html.haml
= link_to 'Back to User Groups', user_groups_path


%h3 Create User Group

= render 'form'

app/views/user_groups/show.html.haml
= link_to 'Edit', edit_user_group_path(@user_group)
\|
= link_to 'Back', user_groups_path

%dl
  %dt Group
  %dd= @user_group.name
  %dt Owners
  %dd
    %ul
      - @user_group.owners.each do |user|
        %li=user.name
  %dt Viwers
  %dd
    %ul
      - @user_group.viewers.each do |user|
        %li=user.name
  %dt Members
  %dd
    %ul
      - @user_group.users.each do |user|
        %li= user.name